/*
# Copyright (C) 2025, Advanced Micro Devices, Inc. All rights reserved.
# SPDX-License-Identifier: X11
*/

#include "hw.h"

void computeD(int D[N][N], int E[N][N]) {
loop_d1:
        for (int i = 0; i < N; ++i) {
            for (int j = 0; j < N; ++j) {
                #pragma HLS PIPELINE II=1
                D[i][j] = 2 * E[i][j];
            }
        }
    }


int top(int A[N][N], int B[N][N], int C[N][N], int D[N][N], int E[N][N], int F[N][N]) {
    int buffer[N][N];

loop1:
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            F[i][j] = i * A[i][j];
        }
    }
// this loop is not named and will show up as process 2
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            C[i][j] = 0;
        }
    }

loop3:
    for (int i = 0; i < N; ++i) {
        // pipelining this loop with II=1 is not possible
        // Code Analyzer will give a performance guidance message
         //#pragma HLS PIPELINE II=1 
L31:
        for (int j = 0; j < N; ++j) {
            #pragma HLS PIPELINE II=1
            C[i][j] += B[i][j] * E[i][j];
        }
    }

loop4:
    for (int i = 0; i < N; ++i) {
        buffer[i][0] = A[i][0];
        for (int j = 1; j < N; ++j) {
            buffer[i][j] = buffer[i][j - 1] + 5;
        }
        A[i][0] = buffer[i][N - 1];
    }

    computeD(D, E);

    return 0;
}
/*
//<copyright-disclaimer-start>
//  * © 2025 Advanced Micro Devices, Inc. All rights reserve
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
///////////////////////////////////////////////////////////////////////////
                                                *
//  * DISCLAIMER                                                                                                 *
//  * The information contained herein is for informational purposes only, and is subject to change              *
//  * without notice. While every precaution has been taken in the preparation of this document, it              *
//  * may contain technical inaccuracies, omissions and typographical errors, and AMD is under no                *
//  * obligation to update or otherwise correct this information.  Advanced Micro Devices, Inc. makes            *
//  * no representations or warranties with respect to the accuracy or completeness of the contents of           *
//  * this document, and assumes no liability of any kind, including the implied warranties of noninfringement,  *
//  * merchantability or fitness for particular purposes, with respect to the operation or use of AMD            *
//  * hardware, software or other products described herein.  No license, including implied or                   *
//  * arising by estoppel, to any intellectual property rights is granted by this document.  Terms and           *
//  * limitations applicable to the purchase or use of AMD’s products are as set forth in a signed agreement     *
//  * between the parties or in AMD's Standard Terms and Conditions of Sale. GD-18                               *
//  *                                                                                                            *
//  **************************************************************************************************************
//<copyright-disclaimer-end>
*/
